/*+
|                                               |
|     Trigger: DTULTATU_GRUPO_CARGO             |  
|     Tabela : GRUPO_CARGO                      |
|                                               |
|     Criao:                                  |
|     14/08/2007 - Luiz Passos                  |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_GRUPO_CARGO
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPO_CARGO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGRCA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDGRUPOCARGO,0) <> NVL(:NEW.CDGRUPOCARGO,0)) OR
           (NVL(:OLD.NMGRUPOCARGO,0) <> NVL(:NEW.NMGRUPOCARGO,0)) OR
           (NVL(:OLD.IDACORESPREQ,0) <> NVL(:NEW.IDACORESPREQ,0)) OR
           (NVL(:OLD.IDACORBLPROJ,0) <> NVL(:NEW.IDACORBLPROJ,0)) OR
           (NVL(:OLD.VRCUSTPADGRC,0) <> NVL(:NEW.VRCUSTPADGRC,0)) OR
           (NVL(:OLD.VRPESOATIVGRC,0) <> NVL(:NEW.VRPESOATIVGRC,0)) THEN
         :NEW.DTULTATUGRCA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GRUPO_CARGO'  , '', 'CDGRUPOCARGO='||:OLD.CDGRUPOCARGO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPO_CARGO MODIFY DTULTATUGRCA DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_GRUPO_CARGO','5.01.008'); END;
/

