IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'NF_BAIXA_AFSAI'  AND
            TYPE = 'TR'                AND
            U.UID = O.UID              AND
            U.NAME = USER)
  DROP TRIGGER NF_BAIXA_AFSAI
  GO

CREATE TRIGGER NF_BAIXA_AFSAI
ON ITEMPRODUTO
FOR INSERT, UPDATE, DELETE

AS

DECLARE @V_DTENTRSAID   DATETIME;
DECLARE @V_IDBAIXAAF    VARCHAR(1);

DECLARE @V_TOTALITEM    NUMERIC(15,6);
DECLARE @V_BAIXATOTAL   NUMERIC(15,6);
DECLARE @V_BAIXAMANUAL  NUMERIC(15,6);
DECLARE @V_EMABERTO     NUMERIC(15,6);
DECLARE @V_BAIXAPARCIAL NUMERIC(15,6);
DECLARE @V_VRFATOCONV   NUMERIC(10,4);

DECLARE @V_IDENTRSAIDOP VARCHAR(1);
DECLARE @V_CDFILIEMIT   VARCHAR(4);
DECLARE @V_CDFILIRECE   VARCHAR(4);
DECLARE @V_NRSOLICMP    VARCHAR(10);

DECLARE @V_CDPRODCNV    VARCHAR(10);
DECLARE @V_VRFATUNEST   NUMERIC(10,4);

DECLARE @V_QTRESTNF     NUMERIC(15,5); --QUANTIDADE QUE IR AUMENTAR OU DIMINUIR NA BAIXA DAS AFS
DECLARE @V_QTBAIXAAF    NUMERIC(15,5); --QUANTIDADE NECESSRIA PARA COMPLETAR A BAIXA DO ITEM DA AF
DECLARE @V_QTUPITEMAF   NUMERIC(15,5); --QUANTIDADE QUE SER AUMENTADA OU DIMINUIDA DA BAIXA DO ITEM DA AF

DECLARE @V_PRODUTO      VARCHAR(10);
DECLARE @V_CDPRODEMIS   VARCHAR(10);
DECLARE @V_IDCONSVLRMAF VARCHAR(1);

DECLARE @V_CDFILDEST    VARCHAR(4);
DECLARE @V_CDFILLANC    VARCHAR(4);
DECLARE @V_NRAUTOFORN   VARCHAR(10);
DECLARE @V_CDMARCA      VARCHAR(5);
DECLARE @V_CDPRODUTO    VARCHAR(10);
DECLARE @V_DTPROGENTAF  DATETIME;
DECLARE @V_QTPROGENTAF  NUMERIC(15,5);
DECLARE @V_QTEFETENTRAF NUMERIC(15,5);
DECLARE @V_IDBAIXITMAF  VARCHAR(1)
DECLARE @V_IDUTILITEM   VARCHAR(1);
DECLARE @V_QTITEMPROD   NUMERIC(15,5);
DECLARE @V_CDFILIAL     VARCHAR(4);
DECLARE @V_NRLANCTONF   VARCHAR(10);

/*VARIVEIS DO CURSOR C_TRG_BAIXA*/
DECLARE @V_ID_TRIGGER      VARCHAR(1);
DECLARE @V_NEW_CDFILDEST   VARCHAR(4);
DECLARE @V_NEW_CDFILIAL    VARCHAR(4);
DECLARE @V_NEW_NRAUTOFORN  VARCHAR(10);
DECLARE @V_NEW_NRLANCTONF  VARCHAR(10);
DECLARE @V_NEW_QTITEMPROD  NUMERIC(10,3);
DECLARE @V_NEW_CDPRODUTO   VARCHAR(10);
DECLARE @V_NEW_CDMARCA     VARCHAR(5);
DECLARE @V_NEW_DTPROGENTAF DATETIME;
DECLARE @V_NEW_CDPRODEMIS  VARCHAR(20);

DECLARE @V_OLD_CDFILDEST   VARCHAR(4);
DECLARE @V_OLD_CDFILIAL    VARCHAR(4);
DECLARE @V_OLD_NRAUTOFORN  VARCHAR(10);
DECLARE @V_OLD_NRLANCTONF  VARCHAR(10);
DECLARE @V_OLD_QTITEMPROD  NUMERIC(15,5);
DECLARE @V_OLD_CDPRODUTO   VARCHAR(10);
DECLARE @V_OLD_CDMARCA     VARCHAR(5);
DECLARE @V_OLD_DTPROGENTAF DATETIME;
DECLARE @V_OLD_CDPRODEMIS  VARCHAR(20);

BEGIN
   SELECT
      @V_IDCONSVLRMAF = ISNULL(MAX(IDCONSVLRMAF), 'N')
   FROM
      PARAMGERAL;

   DECLARE C_TRG_BAIXA CURSOR FOR
      SELECT 'I' AS ID_TRIGGER, CDFILDEST AS NEW_CDFILDEST, CDFILIAL AS NEW_CDFILIAL,
             NRAUTOFORN AS NEW_NRAUTOFORN, NRLANCTONF AS NEW_NRLANCTONF,
             QTITEMPROD AS NEW_QTITEMPROD, CDPRODUTO AS NEW_CDPRODUTO,
             CDMARCA AS NEW_CDMARCA, DTPROGENTAF AS NEW_DTPROGENTAF,
             CDPRODEMIS AS NEW_CDPRODEMIS,
             '' AS OLD_CDFILDEST, '' AS OLD_CDFILIAL,
             '' AS OLD_NRAUTOFORN, '' AS OLD_NRLANCTONF,
             0 AS OLD_QTITEMPROD, '' AS OLD_CDPRODUTO,
             NULL AS OLD_CDMARCA, '' AS OLD_DTPROGENTAF,
             '' AS OLD_CDPRODEMIS
      FROM INSERTED
      WHERE 0 = (SELECT COUNT(*)
                 FROM DELETED)
      UNION
      SELECT 'U' AS ID_TRIGGER, INSERTED.CDFILDEST AS NEW_CDFILDEST, INSERTED.CDFILIAL AS NEW_CDFILIAL,
             INSERTED.NRAUTOFORN AS NEW_NRAUTOFORN, INSERTED.NRLANCTONF AS NEW_NRLANCTONF,
             INSERTED.QTITEMPROD AS NEW_QTITEMPROD, INSERTED.CDPRODUTO AS NEW_CDPRODUTO,
             INSERTED.CDMARCA AS NEW_CDMARCA, INSERTED.DTPROGENTAF AS NEW_DTPROGENTAF,
             INSERTED.CDPRODEMIS AS NEW_CDPRODEMIS,
             DELETED.CDFILDEST AS OLD_CDFILDEST, DELETED.CDFILIAL AS OLD_CDFILIAL,
             DELETED.NRAUTOFORN AS OLD_NRAUTOFORN, DELETED.NRLANCTONF AS OLD_NRLANCTONF,
             DELETED.QTITEMPROD AS OLD_QTITEMPROD, DELETED.CDPRODUTO AS OLD_CDPRODUTO,
             DELETED.CDMARCA AS OLD_CDMARCA, DELETED.DTPROGENTAF AS OLD_DTPROGENTAF,
             DELETED.CDPRODEMIS AS OLD_CDPRODEMIS
      FROM INSERTED, DELETED
      WHERE INSERTED.CDFILIAL    = DELETED.CDFILIAL    AND
            INSERTED.NRLANCTONF  = DELETED.NRLANCTONF  AND
            INSERTED.NRSEQITPROD = DELETED.NRSEQITPROD AND
            (INSERTED.QTITEMPROD <> DELETED.QTITEMPROD)
      UNION
      SELECT 'D' AS ID_TRIGGER, '' AS NEW_CDFILDEST, '' AS NEW_CDFILIAL,
             '' AS NEW_NRAUTOFORN, '' AS NEW_NRLANCTONF,
             0 AS NEW_QTITEMPROD, '' AS NEW_CDPRODUTO,
             '' AS NEW_CDMARCA, '' AS NEW_DTPROGENTAF,
             '' AS NEW_CDPRODEMIS,
             CDFILDEST AS OLD_CDFILDEST, CDFILIAL AS OLD_CDFILIAL,
             NRAUTOFORN AS OLD_NRAUTOFORN, NRLANCTONF AS OLD_NRLANCTONF,
             QTITEMPROD AS OLD_QTITEMPROD, CDPRODUTO AS OLD_CDPRODUTO,
             CDMARCA AS OLD_CDMARCA, DTPROGENTAF AS OLD_DTPROGENTAF,
             CDPRODEMIS AS OLD_CDPRODEMIS
      FROM DELETED
      WHERE 0 = (SELECT COUNT(*)
                 FROM INSERTED);
   OPEN C_TRG_BAIXA;
   FETCH NEXT FROM C_TRG_BAIXA INTO @V_ID_TRIGGER, @V_NEW_CDFILDEST, @V_NEW_CDFILIAL,
                                    @V_NEW_NRAUTOFORN, @V_NEW_NRLANCTONF,
                                    @V_NEW_QTITEMPROD, @V_NEW_CDPRODUTO,
                                    @V_NEW_CDMARCA, @V_NEW_DTPROGENTAF,
                                    @V_NEW_CDPRODEMIS,
                                    @V_OLD_CDFILDEST, @V_OLD_CDFILIAL,
                                    @V_OLD_NRAUTOFORN, @V_OLD_NRLANCTONF,
                                    @V_OLD_QTITEMPROD, @V_OLD_CDPRODUTO,
                                    @V_OLD_CDMARCA, @V_OLD_DTPROGENTAF,
                                    @V_OLD_CDPRODEMIS;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      IF @V_ID_TRIGGER = 'I' BEGIN
         SET @V_CDPRODEMIS = NULL;
         SELECT
            @V_CDPRODEMIS = MAX(CDPRODUTO)
         FROM
            PRODUTO
         WHERE
            CDARVPROD = @V_NEW_CDPRODEMIS;

         IF @V_NEW_CDPRODUTO <> ISNULL(@V_CDPRODEMIS, @V_NEW_CDPRODUTO) BEGIN
            SET @V_PRODUTO = @V_CDPRODEMIS;
         END
         ELSE BEGIN
            SET @V_PRODUTO = @V_NEW_CDPRODUTO;
         END;
      END;

      IF @V_ID_TRIGGER = 'U' BEGIN
         SET @V_CDPRODEMIS = NULL;
         SELECT
            @V_CDPRODEMIS = MAX(CDPRODUTO)
         FROM
            PRODUTO
         WHERE
            CDARVPROD = @V_OLD_CDPRODEMIS;

         IF @V_OLD_CDPRODUTO <> ISNULL(@V_CDPRODEMIS, @V_OLD_CDPRODUTO) BEGIN
            SET @V_PRODUTO = @V_CDPRODEMIS;
         END
         ELSE BEGIN
            SET @V_PRODUTO = @V_OLD_CDPRODUTO;
         END;
         IF @V_PRODUTO IS NULL BEGIN
            SET @V_CDPRODEMIS = NULL;
            SELECT
               @V_CDPRODEMIS = MAX(CDPRODUTO)
            FROM
               PRODUTO
            WHERE
               CDARVPROD = @V_NEW_CDPRODEMIS;

            IF @V_NEW_CDPRODUTO <> ISNULL(@V_CDPRODEMIS, @V_NEW_CDPRODUTO) BEGIN
               SET @V_PRODUTO = @V_CDPRODEMIS;
            END
            ELSE BEGIN
               SET @V_PRODUTO = @V_NEW_CDPRODUTO;
            END;
         END;
      END;

      IF @V_ID_TRIGGER = 'D' BEGIN
         SET @V_CDPRODEMIS = NULL;
         SELECT
            @V_CDPRODEMIS = MAX(CDPRODUTO)
         FROM
            PRODUTO
         WHERE
            CDARVPROD = @V_OLD_CDPRODEMIS;

         IF @V_OLD_CDPRODUTO <> ISNULL(@V_CDPRODEMIS, @V_OLD_CDPRODUTO) BEGIN
            SET @V_PRODUTO = @V_CDPRODEMIS;
         END
         ELSE BEGIN
            SET @V_PRODUTO = @V_OLD_CDPRODUTO;
         END;
      END;
      
      SELECT @V_NRLANCTONF = MAX(N.NRLANCTONF),
             @V_VRFATOCONV = MAX(ISNULL(ROUND(D.VRFATUNEST/C.VRFATUNEST,2),1))
      FROM NFRELACAFSAI N, ITEMAUTF I, CNVPRODUNEST C, RELACPRODOL R, CNVPRODUNEST D
      WHERE ((@V_OLD_CDFILIAL    = N.CDFILIAL       AND
              @V_OLD_NRLANCTONF  = N.NRLANCTONF)    OR
             (@V_NEW_CDFILIAL    = N.CDFILIAL       AND
              @V_NEW_NRLANCTONF  = N.NRLANCTONF))   AND
             N.CDFILDEST   = I.CDFILDEST          AND
             N.CDFILLANC   = I.CDFILLANC          AND
             N.NRAUTOFORN  = I.NRAUTOFORN         AND
             N.CDMARCA     = I.CDMARCA            AND
             N.CDPRODUTO   = I.CDPRODUTO          AND
             N.DTPROGENTAF = I.DTPROGENTAF        AND
             R.CDPRARVORIG = I.CDPRODUTO          AND
             R.CDMARCA     = ISNULL(I.CDMARCAOL, I.CDMARCA) AND
             R.CDPRODARVOL = C.CDPRUNEST          AND
             C.CDPRODUTO   = D.CDPRODUTO          AND
             D.CDPRUNEST   = @V_PRODUTO;

      IF @V_NRLANCTONF IS NULL BEGIN
         SELECT @V_NRLANCTONF = MAX(N.NRLANCTONF),
                @V_VRFATOCONV = MAX(ISNULL(ROUND(D.VRFATUNEST/C.VRFATUNEST,2),1))
         FROM NFRELACPEXOL N, ITEMPEDEXOL I, CNVPRODUNEST C, RELACPRODOL R, CNVPRODUNEST D
         WHERE ((@V_OLD_CDFILIAL    = N.CDFILIAL       AND
                 @V_OLD_NRLANCTONF  = N.NRLANCTONF)    OR
                (@V_NEW_CDFILIAL    = N.CDFILIAL       AND
                 @V_NEW_NRLANCTONF  = N.NRLANCTONF))   AND
               N.CDFILDEST    = I.CDFILDEST          AND
               N.CDFILLANC    = I.CDFILLANC          AND
               N.NRPEDEXOL    = I.NRPEDEXOL          AND
               N.CDMARCA      = I.CDMARCA            AND
               N.CDPRODUTO    = I.CDPRODUTO          AND
               N.DTPROGENPEOL = I.DTPROGENPEOL       AND
               R.CDPRARVORIG  = I.CDPRODUTO          AND
               R.CDMARCA      = ISNULL(I.CDMARCA, I.CDMARCA) AND
               R.CDPRODARVOL  = C.CDPRUNEST          AND
               C.CDPRODUTO    = D.CDPRODUTO          AND
               D.CDPRUNEST    = @V_PRODUTO;
      END;

      IF NOT (@V_NRLANCTONF IS NULL) BEGIN
         IF @V_ID_TRIGGER = 'I' BEGIN
            SET @V_QTRESTNF   = @V_NEW_QTITEMPROD * @V_VRFATOCONV;
            SET @V_QTITEMPROD = @V_NEW_QTITEMPROD * @V_VRFATOCONV;
         END;
         IF @V_ID_TRIGGER = 'U' BEGIN
            SET @V_QTRESTNF   = (@V_NEW_QTITEMPROD - @V_OLD_QTITEMPROD) * @V_VRFATOCONV;
            SET @V_QTITEMPROD = (@V_NEW_QTITEMPROD - @V_OLD_QTITEMPROD) * @V_VRFATOCONV;
         END;
         IF @V_ID_TRIGGER = 'D' BEGIN
            SET @V_QTRESTNF   = - (@V_OLD_QTITEMPROD * @V_VRFATOCONV);
            SET @V_QTITEMPROD = @V_OLD_QTITEMPROD * @V_VRFATOCONV;
         END;

         SET @V_QTRESTNF   = ROUND(@V_QTRESTNF, 2);
         SET @V_QTITEMPROD = ROUND(@V_QTITEMPROD, 2);

         IF @V_ID_TRIGGER = 'I' BEGIN
            DECLARE C_ITEMAUFSAI_INSERT CURSOR FOR
            SELECT
               ITEMAUTF.CDFILDEST,
               ITEMAUTF.CDFILLANC,
               ITEMAUTF.NRAUTOFORN,
               ITEMAUTF.CDMARCA,
               ITEMAUTF.CDPRODUTO,
               ITEMAUTF.DTPROGENTAF,
               ITEMAUTF.QTPROGENTAF,
               ISNULL(ITEMAUTF.QTEFAFSAIDOL, 0) AS QTSAIDOPLOG,
               ITEMAUTF.IDBAIXITAFS,
               '1' AS IDUTILITEM
            FROM
               ITEMAUTF, NFRELACAFSAI N, RELACPRODOL R, CNVPRODUNEST C, CNVPRODUNEST D
            WHERE
               ((@V_OLD_CDFILIAL   = N.CDFILIAL AND
                 @V_OLD_NRLANCTONF = N.NRLANCTONF) OR
                (@V_NEW_CDFILIAL   = N.CDFILIAL AND
                 @V_NEW_NRLANCTONF = N.NRLANCTONF))  AND
               N.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
               N.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
               N.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
               N.CDMARCA     = ITEMAUTF.CDMARCA     AND
               N.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
               N.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
               R.CDPRARVORIG = ITEMAUTF.CDPRODUTO   AND
               R.CDMARCA     = ISNULL(ITEMAUTF.CDMARCAOL, ITEMAUTF.CDMARCA) AND
               R.CDPRODARVOL = C.CDPRUNEST          AND
               C.CDPRODUTO   = D.CDPRODUTO          AND
               D.CDPRUNEST   = @V_PRODUTO
            UNION
            SELECT
               ITEMPEDEXOL.CDFILDEST,
               ITEMPEDEXOL.CDFILLANC,
               ITEMPEDEXOL.NRPEDEXOL,
               ITEMPEDEXOL.CDMARCA,
               ITEMPEDEXOL.CDPRODUTO,
               ITEMPEDEXOL.DTPROGENPEOL,
               ITEMPEDEXOL.QTPROGENPEOL,
               ISNULL(ITEMPEDEXOL.QTEFETENPEOL, 0) AS QTSAIDOPLOG,
               ITEMPEDEXOL.IDBAIXAOLSAI,
               '2' AS IDUTILITEM
            FROM
               ITEMPEDEXOL, NFRELACPEXOL N, RELACPRODOL R, CNVPRODUNEST C, CNVPRODUNEST D
            WHERE
               ((@V_OLD_CDFILIAL    = N.CDFILIAL AND
                 @V_OLD_NRLANCTONF  = N.NRLANCTONF) OR
                (@V_NEW_CDFILIAL    = N.CDFILIAL AND
                 @V_NEW_NRLANCTONF  = N.NRLANCTONF))  AND
               N.CDFILDEST    = ITEMPEDEXOL.CDFILDEST   AND
               N.CDFILLANC    = ITEMPEDEXOL.CDFILLANC   AND
               N.NRPEDEXOL    = ITEMPEDEXOL.NRPEDEXOL  AND
               N.CDMARCA      = ITEMPEDEXOL.CDMARCA     AND
               N.CDPRODUTO    = ITEMPEDEXOL.CDPRODUTO   AND
               N.DTPROGENPEOL = ITEMPEDEXOL.DTPROGENPEOL AND
               R.CDPRARVORIG  = ITEMPEDEXOL.CDPRODUTO   AND
               R.CDMARCA      = ISNULL(ITEMPEDEXOL.CDMARCA, ITEMPEDEXOL.CDMARCA) AND
               R.CDPRODARVOL  = C.CDPRUNEST          AND
               C.CDPRODUTO    = D.CDPRODUTO          AND
               D.CDPRUNEST    = @V_PRODUTO
            ORDER BY
               1, 2, 3, 6;
            OPEN C_ITEMAUFSAI_INSERT;
            FETCH NEXT FROM C_ITEMAUFSAI_INSERT INTO @V_CDFILDEST,
                                                     @V_CDFILLANC,
                                                     @V_NRAUTOFORN,
                                                     @V_CDMARCA,
                                                     @V_CDPRODUTO,
                                                     @V_DTPROGENTAF,
                                                     @V_QTPROGENTAF,
                                                     @V_QTEFETENTRAF,
                                                     @V_IDBAIXITMAF,
                                                     @V_IDUTILITEM;
         END ELSE BEGIN
            DECLARE C_ITEMAUFSAI CURSOR FOR
            SELECT
               ITEMAUTF.CDFILDEST,
               ITEMAUTF.CDFILLANC,
               ITEMAUTF.NRAUTOFORN,
               ITEMAUTF.CDMARCA,
               ITEMAUTF.CDPRODUTO,
               ITEMAUTF.DTPROGENTAF,
               ITEMAUTF.QTPROGENTAF,
               ISNULL(ITEMAUTF.QTEFAFSAIDOL, 0) AS QTSAIDOPLOG,
               ITEMAUTF.IDBAIXITAFS,
               '1' AS IDUTILITEM
            FROM
               ITEMAUTF, NFRELACAFSAI N, RELACPRODOL R, CNVPRODUNEST C, CNVPRODUNEST D
            WHERE
               ((@V_OLD_CDFILIAL    = N.CDFILIAL AND
                 @V_OLD_NRLANCTONF  = N.NRLANCTONF) OR
                (@V_NEW_CDFILIAL    = N.CDFILIAL AND
                 @V_NEW_NRLANCTONF  = N.NRLANCTONF))  AND
               N.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
               N.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
               N.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
               N.CDMARCA     = ITEMAUTF.CDMARCA     AND
               N.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
               N.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
               R.CDPRARVORIG = ITEMAUTF.CDPRODUTO   AND
               R.CDMARCA     = ISNULL(ITEMAUTF.CDMARCAOL, ITEMAUTF.CDMARCA) AND
               R.CDPRODARVOL = C.CDPRUNEST          AND
               C.CDPRODUTO   = D.CDPRODUTO          AND
               D.CDPRUNEST   = @V_PRODUTO
            UNION
            SELECT
               ITEMPEDEXOL.CDFILDEST,
               ITEMPEDEXOL.CDFILLANC,
               ITEMPEDEXOL.NRPEDEXOL,
               ITEMPEDEXOL.CDMARCA,
               ITEMPEDEXOL.CDPRODUTO,
               ITEMPEDEXOL.DTPROGENPEOL,
               ITEMPEDEXOL.QTPROGENPEOL,
               ISNULL(ITEMPEDEXOL.QTEFETENPEOL, 0) AS QTSAIDOPLOG,
               ITEMPEDEXOL.IDBAIXAOLSAI,
               '2' AS IDUTILITEM
            FROM
               ITEMPEDEXOL, NFRELACPEXOL N, RELACPRODOL R, CNVPRODUNEST C, CNVPRODUNEST D
            WHERE
               ((@V_OLD_CDFILIAL    = N.CDFILIAL AND
                 @V_OLD_NRLANCTONF  = N.NRLANCTONF) OR
                (@V_NEW_CDFILIAL    = N.CDFILIAL AND
                 @V_NEW_NRLANCTONF  = N.NRLANCTONF))  AND
               N.CDFILDEST    = ITEMPEDEXOL.CDFILDEST   AND
               N.CDFILLANC    = ITEMPEDEXOL.CDFILLANC   AND
               N.NRPEDEXOL    = ITEMPEDEXOL.NRPEDEXOL  AND
               N.CDMARCA      = ITEMPEDEXOL.CDMARCA     AND
               N.CDPRODUTO    = ITEMPEDEXOL.CDPRODUTO   AND
               N.DTPROGENPEOL = ITEMPEDEXOL.DTPROGENPEOL AND
               R.CDPRARVORIG  = ITEMPEDEXOL.CDPRODUTO   AND
               R.CDMARCA      = ISNULL(ITEMPEDEXOL.CDMARCA, ITEMPEDEXOL.CDMARCA) AND
               R.CDPRODARVOL  = C.CDPRUNEST          AND
               C.CDPRODUTO    = D.CDPRODUTO          AND
               D.CDPRUNEST    = @V_PRODUTO
            ORDER BY
               1, 2, 3, 6;
            OPEN C_ITEMAUFSAI;
            FETCH NEXT FROM C_ITEMAUFSAI INTO @V_CDFILDEST,
                                              @V_CDFILLANC,
                                              @V_NRAUTOFORN,
                                              @V_CDMARCA,
                                              @V_CDPRODUTO,
                                              @V_DTPROGENTAF,
                                              @V_QTPROGENTAF,
                                              @V_QTEFETENTRAF,
                                              @V_IDBAIXITMAF,
                                              @V_IDUTILITEM;
         END;

         WHILE (@@FETCH_STATUS = 0)
         BEGIN

            SET @V_QTBAIXAAF = @V_QTPROGENTAF - @V_QTEFETENTRAF; -- QUNATIDADE NECESSRIA PARA COMPLETAR O CAMPO QTEFETENTRAF

            IF @V_QTRESTNF <> 0 BEGIN --SE O ITEM NO ESTA BAIXADO TOTALMENTE E HOVER QUANTIDADE A SER ATUALIZADA NA BAIXA DO...
               SET @V_QTUPITEMAF = @V_QTRESTNF;

               IF @V_QTRESTNF > 0 BEGIN                        /* ################################################ */
                  IF @V_QTRESTNF > @V_QTBAIXAAF BEGIN          /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                     SET @V_QTUPITEMAF = @V_QTBAIXAAF;            /* ################################################ */
                  END ELSE BEGIN                              /* ################################################ */
                     IF ABS(@V_QTRESTNF) > @V_QTEFETENTRAF BEGIN   /* AJUSTE DA QUANTIDATE A SER SOMADA NA BAIXA DA AF */
                        SET @V_QTUPITEMAF = @V_QTEFETENTRAF * (-1);  /* ################################################ */
                     END;
                  END;

                  SET @V_QTRESTNF = @V_QTRESTNF - @V_QTUPITEMAF;

                  IF @V_QTPROGENTAF <= @V_QTEFETENTRAF + @V_QTUPITEMAF BEGIN /* ################################################ */
                     SET @V_IDBAIXITMAF = '2';                                                   /* AJUSTE DO IDENTIFICADOR DE BAIXA DO ITEM DA AF   */
                  END ELSE BEGIN
                     IF (@V_IDCONSVLRMAF = 'S') AND (@V_IDBAIXITMAF = '2') AND (@V_QTITEMPROD < @V_QTPROGENTAF) BEGIN
                        SET @V_IDBAIXITMAF = NULL;
                     END ELSE BEGIN
                        SET @V_IDBAIXITMAF = '1';
                     END;
                  END;

                  IF @V_QTEFETENTRAF + @V_QTUPITEMAF = 0 BEGIN
                     SET @V_IDBAIXITMAF = NULL;
                     SET @V_DTENTRSAID  = NULL;
                  END;
                  SET @V_QTEFETENTRAF = @V_QTEFETENTRAF + @V_QTUPITEMAF;

                  IF @V_QTEFETENTRAF = 0 BEGIN
                     SET @V_QTEFETENTRAF = NULL;
                  END;

                  IF @V_IDUTILITEM = '1' BEGIN
                     UPDATE ITEMAUTF
                     SET  IDBAIXITAFS  = @V_IDBAIXITMAF,
                          QTEFAFSAIDOL = @V_QTEFETENTRAF,
                          DTEFETENTAF  = @V_DTENTRSAID,
                          CDOPERBAIXA  = NULL,
                          DTBAIXITMAF  = NULL
                     WHERE
                        @V_CDFILDEST   = ITEMAUTF.CDFILDEST  AND
                        @V_CDFILLANC   = ITEMAUTF.CDFILLANC  AND
                        @V_NRAUTOFORN  = ITEMAUTF.NRAUTOFORN AND
                        @V_CDPRODUTO   = ITEMAUTF.CDPRODUTO  AND
                        @V_CDMARCA     = ITEMAUTF.CDMARCA    AND
                        @V_DTPROGENTAF = ITEMAUTF.DTPROGENTAF;
                  END;

                  IF @V_IDUTILITEM = '2' BEGIN
                     UPDATE ITEMPEDEXOL
                     SET  IDBAIXAOLSAI  = @V_IDBAIXITMAF,
                          QTEFETENPEOL  = @V_QTEFETENTRAF,
                          DTEFETENPEOL  = @V_DTENTRSAID,
                          CDOPERBAIXA   = NULL,
                          DTBAIXTMPEOL  = NULL
                     WHERE
                        @V_CDFILDEST   = ITEMPEDEXOL.CDFILDEST AND
                        @V_CDFILLANC   = ITEMPEDEXOL.CDFILLANC AND
                        @V_NRAUTOFORN  = ITEMPEDEXOL.NRPEDEXOL AND
                        @V_CDPRODUTO   = ITEMPEDEXOL.CDPRODUTO AND
                        @V_CDMARCA     = ITEMPEDEXOL.CDMARCA   AND
                        @V_DTPROGENTAF = ITEMPEDEXOL.DTPROGENPEOL;
                  END;

                  IF @V_IDBAIXITMAF IS NULL BEGIN

                     IF @V_IDUTILITEM = '1' BEGIN
                        DELETE FROM NFRELACAFSAI
                        WHERE
                           @V_CDFILDEST   = CDFILDEST  AND
                           @V_CDFILLANC   = CDFILLANC  AND
                           @V_NRAUTOFORN  = NRAUTOFORN AND
                           @V_CDPRODUTO   = CDPRODUTO  AND
                           @V_CDMARCA     = CDMARCA    AND
                           @V_DTPROGENTAF = DTPROGENTAF;
                     END;

                     IF @V_IDUTILITEM = '2' BEGIN
                        DELETE FROM NFRELACPEXOL
                        WHERE
                           @V_CDFILDEST   = CDFILDEST AND
                           @V_CDFILLANC   = CDFILLANC AND
                           @V_NRAUTOFORN  = NRPEDEXOL AND
                           @V_CDPRODUTO   = CDPRODUTO AND
                           @V_CDMARCA     = CDMARCA AND
                           @V_DTPROGENTAF = DTPROGENPEOL;
                     END;
                  END;
               END;

               SET @V_TOTALITEM    = 0;
               SET @V_BAIXATOTAL   = 0;
               SET @V_BAIXAMANUAL  = 0;
               SET @V_EMABERTO     = 0;
               SET @V_BAIXAPARCIAL = 0;

               IF @V_IDUTILITEM = '1' BEGIN
                  SELECT @V_TOTALITEM = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF
                  FROM ITEMAUTF
                  WHERE
                     @V_CDFILDEST  = ITEMAUTF.CDFILDEST AND
                     @V_CDFILLANC  = ITEMAUTF.CDFILLANC AND
                     @V_NRAUTOFORN = ITEMAUTF.NRAUTOFORN;

                  SELECT @V_EMABERTO = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
                  FROM ITEMAUTF
                  WHERE
                     @V_CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                     @V_CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                     @V_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS IS NULL;

                  SELECT @V_BAIXAPARCIAL = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
                  FROM ITEMAUTF
                  WHERE
                     @V_CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                     @V_CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                     @V_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS = '1';

                  SELECT @V_BAIXATOTAL = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
                  FROM ITEMAUTF
                  WHERE
                     @V_CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                     @V_CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                     @V_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS = '2';

                  SELECT @V_BAIXAMANUAL = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
                  FROM ITEMAUTF
                  WHERE
                     @V_CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                     @V_CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                     @V_NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                     ITEMAUTF.IDBAIXITAFS = '3';
               END;

               IF @V_IDUTILITEM = '2' BEGIN
                  SELECT @V_TOTALITEM = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF
                  FROM ITEMPEDEXOL
                  WHERE
                     @V_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     @V_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     @V_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL;

                  SELECT @V_EMABERTO = COUNT(*)    -- BUSCA O TOTAL DE ITENS DA AF EM ABERTO
                  FROM ITEMPEDEXOL
                  WHERE
                     @V_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     @V_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     @V_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI IS NULL;

                  SELECT @V_BAIXAPARCIAL = COUNT(*)   -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA PARCIAL
                  FROM ITEMPEDEXOL
                  WHERE
                     @V_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     @V_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     @V_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI = '1';

                  SELECT @V_BAIXATOTAL = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA TOTAL
                  FROM ITEMPEDEXOL
                  WHERE
                     @V_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     @V_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     @V_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI = '2';

                  SELECT @V_BAIXAMANUAL = COUNT(*)  -- BUSCA O TOTAL DE ITENS DA AF COM BAIXA MANUAL
                  FROM ITEMPEDEXOL
                  WHERE
                     @V_CDFILDEST  = ITEMPEDEXOL.CDFILDEST AND
                     @V_CDFILLANC  = ITEMPEDEXOL.CDFILLANC AND
                     @V_NRAUTOFORN = ITEMPEDEXOL.NRPEDEXOL AND
                     ITEMPEDEXOL.IDBAIXAOLSAI = '3';
               END;

               IF @V_TOTALITEM = @V_EMABERTO BEGIN
                  SET @V_IDBAIXAAF = NULL;  -- AF EM ABERTO
               END;
               IF @V_TOTALITEM = @V_BAIXATOTAL BEGIN
                  SET @V_IDBAIXAAF = '2';   -- AF COM BAIXA TOTAL
               END;
               IF @V_BAIXAPARCIAL > 0 BEGIN
                  SET @V_IDBAIXAAF = '1';   -- AF COM BAIXA PARCIAL
               END;
               IF (@V_TOTALITEM = @V_BAIXATOTAL + @V_BAIXAMANUAL) AND (@V_BAIXAMANUAL > 0) BEGIN
                  SET @V_IDBAIXAAF = '3';   -- AF COM BAIXA MANUAL
               END;
               IF (@V_TOTALITEM = @V_BAIXATOTAL + @V_BAIXAMANUAL + @V_EMABERTO) AND
                  (@V_EMABERTO > 0) AND (@V_EMABERTO < @V_TOTALITEM) BEGIN
                  SET @V_IDBAIXAAF = '1';   -- AF COM BAIXA PARCIAL
               END;

               IF @V_IDUTILITEM = '1' BEGIN
                  UPDATE AUTOFORNE  -- ALTERA O ID DE BAIXA DA AF
                  SET IDBAIXAFSAI = @V_IDBAIXAAF
                  WHERE
                     @V_CDFILDEST  = AUTOFORNE.CDFILDEST AND
                     @V_CDFILLANC  = AUTOFORNE.CDFILLANC AND
                     @V_NRAUTOFORN = AUTOFORNE.NRAUTOFORN;
               END;

               IF @V_IDUTILITEM = '2' BEGIN
                  UPDATE PEDIDOEXOL  -- ALTERA O ID DE BAIXA DA AF
                  SET IDBAIXEXSAI = @V_IDBAIXAAF
                  WHERE
                     @V_CDFILDEST  = PEDIDOEXOL.CDFILDEST AND
                     @V_CDFILLANC  = PEDIDOEXOL.CDFILLANC AND
                     @V_NRAUTOFORN = PEDIDOEXOL.NRPEDEXOL;
               END;
            END;
            IF @V_ID_TRIGGER = 'I' BEGIN
               FETCH NEXT FROM C_ITEMAUFSAI_INSERT INTO @V_CDFILDEST,
                                                        @V_CDFILLANC,
                                                        @V_NRAUTOFORN,
                                                        @V_CDMARCA,
                                                        @V_CDPRODUTO,
                                                        @V_DTPROGENTAF,
                                                        @V_QTPROGENTAF,
                                                        @V_QTEFETENTRAF,
                                                        @V_IDBAIXITMAF,
                                                        @V_IDUTILITEM;
            END
            ELSE BEGIN
               FETCH NEXT FROM C_ITEMAUFSAI INTO @V_CDFILDEST,
                                                 @V_CDFILLANC,
                                                 @V_NRAUTOFORN,
                                                 @V_CDMARCA,
                                                 @V_CDPRODUTO,
                                                 @V_DTPROGENTAF,
                                                 @V_QTPROGENTAF,
                                                 @V_QTEFETENTRAF,
                                                 @V_IDBAIXITMAF,
                                                 @V_IDUTILITEM;
            END;
         END;
         IF @V_ID_TRIGGER = 'I' BEGIN
            CLOSE C_ITEMAUFSAI_INSERT;
            DEALLOCATE C_ITEMAUFSAI_INSERT;
         END ELSE BEGIN
            CLOSE C_ITEMAUFSAI;
            DEALLOCATE C_ITEMAUFSAI;
         END;

         SELECT
            @V_CDPRODCNV = MAX(PRODUTO.CDARVPROD),
            @V_VRFATUNEST = MAX(CNVPRODUNEST.VRFATUNEST)
         FROM
            CNVPRODUNEST, PRODUTO
         WHERE
            CNVPRODUNEST.CDPRODUTO = PRODUTO.CDPRODUTO AND
            (CNVPRODUNEST.CDPRUNEST = @V_OLD_CDPRODUTO OR CNVPRODUNEST.CDPRUNEST = @V_NEW_CDPRODUTO);

         IF @V_CDPRODCNV IS NULL BEGIN
            SET @V_CDPRODCNV = ISNULL(@V_OLD_CDPRODUTO, @V_NEW_CDPRODUTO);
         END;

         IF @V_VRFATUNEST IS NULL BEGIN
            SET @V_VRFATUNEST = 1;
         END;
      END;
      FETCH NEXT FROM C_TRG_BAIXA INTO @V_ID_TRIGGER, @V_NEW_CDFILDEST, @V_NEW_CDFILIAL,
                                       @V_NEW_NRAUTOFORN, @V_NEW_NRLANCTONF,
                                       @V_NEW_QTITEMPROD, @V_NEW_CDPRODUTO,
                                       @V_NEW_CDMARCA, @V_NEW_DTPROGENTAF,
                                       @V_NEW_CDPRODEMIS,
                                       @V_OLD_CDFILDEST, @V_OLD_CDFILIAL,
                                       @V_OLD_NRAUTOFORN, @V_OLD_NRLANCTONF,
                                       @V_OLD_QTITEMPROD, @V_OLD_CDPRODUTO,
                                       @V_OLD_CDMARCA, @V_OLD_DTPROGENTAF,
                                       @V_OLD_CDPRODEMIS;
   END;
   CLOSE C_TRG_BAIXA;
   DEALLOCATE C_TRG_BAIXA;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'NF_BAIXA_AFSAI','4.11.089';
GO

